#include ".\sudokugrid.h"

SudokuGrid::SudokuGrid() {
	newGame();
}

void SudokuGrid::newGame() {
	int difficulty=0;
	if (MessageBox(NULL, "Would you like to play on Hard Difficulty?", "Difficulty", MB_YESNO)==7) {
		difficulty=0;
	} else {
		difficulty=1;
	}
	while (!createSolution()) {}
	initialProgress(difficulty);
}

SudokuGrid::~SudokuGrid(void) {
}

bool SudokuGrid::createSolution() {
	srand((unsigned int)time(NULL));
	int starter = 10*(rand()%814)-1;
	fstream in;
	char temp[256], space;
	in.open("sol.sdu", fstream::in);
	for (int i=0; i<=starter; i++) {
		in.getline(temp,256);
	}
	for (unsigned int i=0;i<9;i++) {
		for (unsigned int j=0;j<9;j++) {
			solution[i][j] = (int)in.get()-48;
			space = in.get();
		}
		in.getline(temp, 256);
	}
	in.close();

	return true;
}

void SudokuGrid::initialProgress(unsigned int difficulty) {
	for (int i=0;i<9;i++) {
		for (int j=0;j<9;j++) {
			for (int k=0;k<10;k++) {
				progress[i][j][k]=k;
			}
			//cout << progress[i][j][0] << " ";
		}
		//cout << endl;
	}

	int filledBlocks=44-difficulty*10;
	srand((unsigned int)time(NULL));
	while (filledBlocks>0) {
		unsigned int r=rand()%9;
		unsigned int s=rand()%9;
		if (progress[r][s][0] == 0) {
			progress[r][s][0] = solution[r][s];
			progress[8-r][8-s][0] = solution[8-r][8-s];
			for (int q=1;q<10;q++) {
				progress[r][s][q]=10;
				progress[8-r][8-s][q]=10;
			}
			filledBlocks-=2;
		}
		//cout << filledBlocks << ", " << r << ", " << s << endl;
	}
}

void SudokuGrid::displaySol() {
	for (int i=0;i<9;i++) {
		for (int j=0;j<9;j++) {
			cout << solution[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
}

void SudokuGrid::display() {
	for (int i=0;i<9;i++) {
		for (int j=0;j<9;j++) {
			cout << progress[i][j][0] << " ";
		}
		cout << endl;
	}
}

bool SudokuGrid::checkComplete() {
	bool check[9] = { false, false, false, false, false, false, false, false, false };
	// check each row
	for (int i=0; i<9; i++) {
		for (int j=0; j<9; j++) {
			check[progress[i][j][0]-1]=true;
		}
		for (int k=0; k<9; k++) {
			if (check[k] == false) { return false; }
			check[k]=false;
		}
	}
	
	// check each column
	for (int i=0; i<9; i++) {
		for (int j=0; j<9; j++) {
			check[progress[j][i][0]-1]=true;
		}
		for (int k=0; k<9; k++) {
			if (check[k] == false) { return false; }
			check[k]=false;
		}
	}
	
	// check each square
	for (int q=0; q<3; q++) {
		for (int r=0; r<3; r++) {
			for (int i=0+q*3; i<3+q*3; i++) {
				for (int j=(0+r*3); j<(3+r*3); j++) {
					check[progress[i][j][0]-1]=true;
				}
			}
			for (int k=0; k<9; k++) {
				if (check[k] == false) { return false; }
				check[k]=false;
			}
		}
	}
	
	// if it passes all the requirements, then the puzzle is complete
	return true;
}