#pragma once
#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glut.h>
#include <math.h>
#include <time.h>
#include <iostream>
#include <fstream>
using namespace std;

class SudokuGrid {
private:
	unsigned int solution[9][9], progress[9][9][10];
	bool createSolution();
	void initialProgress(unsigned int difficulty);
public:
	SudokuGrid();
	~SudokuGrid(void);
	void displaySol();
	void display();
	unsigned int getProgress(unsigned int r, unsigned int c) const {
		return progress[r][c][0];
	}
	bool getDepth(unsigned int r, unsigned int c, unsigned int d) const {
		return (progress[r][c][d]==d);
	}
	void setSpot(unsigned int r, unsigned int c, unsigned int d) {
		progress[r][c][0]=d;
	}
	void narrowChoice(unsigned int r, unsigned int c, unsigned int d) {
		progress[r][c][d]=0;
	}
	void resetChoices(unsigned int r, unsigned int c) {
		for (unsigned int d=1;d<10;d++) {
			progress[r][c][d]=d;
		}
	}
	bool checkIfInitial(unsigned int r, unsigned int c) {
		return (progress[r][c][1]==10);
	}
	void newGame();
	bool checkComplete();
};
